/******************************************************************************
**+-------------------------------------------------------------------------+**
**|                            ****                                         |**
**|                            ****                                         |**
**|                            ******o***                                   |**
**|                      ********_///_****                                  |**
**|                      ***** /_//_/ ****                                  |**
**|                       ** ** (__/ ****                                   |**
**|                           *********                                     |**
**|                            ****                                         |**
**|                            ***                                          |**
**|                                                                         |**
**|         Copyright (c) 2006 - 2010    Texas Instruments Incorporated     |**
**|                        ALL RIGHTS RESERVED                              |**
**|                                                                         |**
**| Permission is hereby granted to licensees of Texas Instruments          |**
**| Incorporated (TI) products to use this computer program for the sole    |**
**| purpose of implementing a licensee product based on TI products.        |**
**| No other rights to reproduce, use, or disseminate this computer         |**
**| program, whether in part or in whole, are granted.                      |**
**|                                                                         |**
**| TI makes no representation or warranties with respect to the            |**
**| performance of this computer program, and specifically disclaims        |**
**| any responsibility for any damages, special or consequential,           |**
**| connected with the use of this program.                                 |**
**|                                                                         |**
**+-------------------------------------------------------------------------+**
******************************************************************************/
#include "data_types.h"
#include "register_dma.h"
#include "register_cpu.h"
#include "dma.h"

#define AUTO_RELOAD     1

extern Uint16 ppsize;
extern Int16 pingbuffer[ppsize];


void set_dma0_ch0_stop(void)
{
	Uint16 temp;
//  DMA stop
    temp = DMA0_CH0_TC_MSW;
	temp &= 0x7FFF;
	DMA0_CH0_TC_MSW = temp;    
}


Uint16 set_dma0_ch0_i2s0_Rin(void)   //
{
	Uint16 temp; 
	Uint32 add;

    DMA0_CH0_TC_LSW = ppsize*2;

#if(AUTO_RELOAD ==1)        
    DMA0_CH0_TC_MSW = 0x3084;     //src fix, destination incre, sync, auto
#else
    DMA0_CH0_TC_MSW = 0x2204;     //src incre, destination fix, sync, No auto  
#endif
                
	temp = DMA0_CH10_EVENT_SRC;
    DMA0_CH10_EVENT_SRC = temp | 0x0001;   // I2S transmit event
    

     add = (Uint32)pingbuffer;
    
    add = (add<<1) + 0x080000;		// change word address to byte address and add SARAM offset for DMA
    DMA0_CH0_DST_LSW = (Uint16)add;
    
    DMA0_CH0_DST_MSW = 0xFFFF & (add >> 16);
    
    DMA0_CH0_SRC_LSW = 0x282D;      // is20 transmit  DMAԴַ  λߵλ
    
//  DMA starts   
    temp = DMA0_CH0_TC_MSW;
	temp |= 0x8000;
	DMA0_CH0_TC_MSW = temp;

    return 0;
}


void enable_dma_int(void)
{
    DMA_MSK = 0xFFFF;     // enable all interrupts
    DMA_IFR = 0xFFFF;     // clear interrupt flags
}


interrupt void DMA_Isr(void)
{   
    Uint16 temp,i;
    
    temp = IFR0;
    IFR0 = temp;  

	temp = DMA_IFR;
    DMA_IFR = temp;     // clear interrupt flags

	    
}

